class LessTele expands mutator config(LessTele);

var bool bPostInit;
var config bool bVerbose;
var config int SpawnRadius;
var DeathMatchPlus MyGame;

event PostBeginPlay()
{
	if (!bPostInit)
	{
		bPostInit = True;
		if ( DeathMatchPlus(Level.Game) != None )
			MyGame = DeathMatchPlus(Level.Game);
		log (Self@" has been loaded and started.");
		if ( SpawnRadius < 100 )
			SpawnRadius = 100;
		if ( SpawnRadius > 710 )
			SpawnRadius = 710;
		SaveConfig();
	}
	else
	{
		log (Self@" being already started has been called again, please check your configuration...");
		return;
	}
}

function ModifyPlayer (Pawn Other)
{
	local Pawn aPawn, OtherPawn;
	local NavigationPoint N;
	local bool bSpotBusy, bStillBusy, bJobDone;

	if ( Other.PlayerReplicationInfo == None ) return; //Don't let something to mess up - block chain by default

	if ( MyGame != None )
	{
		foreach Other.RadiusActors (class 'Pawn',aPawn,30)
		{
			if ( aPawn != Other )
			{
				if ( bVerbose && MyGame.bStartMatch )
					log ( Other.GetHumanName()@"might be colliding with"@aPawn.GetHumanName() );
				bSpotBusy = True;
				break;
			}
		}
		if ( bSpotBusy )
		{
			foreach Other.RadiusActors( class'NavigationPoint',N,SpawnRadius )
			{
				if ( Teleporter(N) == None )
				{
					if ( bVerbose && MyGame.bStartMatch )
						log ( "Testing"@N.Name@"if available...");
					bStillBusy = False;
					foreach N.RadiusActors (class 'Pawn',OtherPawn,30)
					{
						if ( OtherPawn != Other )
						{
							if ( bVerbose && MyGame.bStartMatch )
								log ( N.Name@"is not available."@OtherPawn.GetHumanName()@"has been found there.");
							bStillBusy = True;
							break;
						}
					}
				}
				if (!bStillBusy)
				{
					bJobDone = Other.SetLocation(N.Location);
					break;
				}
			}
			if (bJobDone)
			{
				if ( bVerbose && MyGame.bStartMatch )
					log ( Other.GetHumanName()@"will use"@N.Name@"for start...");
			}
		}
	}
	Super.ModifyPlayer(Other);
}

defaultproperties
{
   bVerbose=True
   SpawnRadius=500
}